'*******************************************************************************
'
'                            SSD1963 LCD Test
'
'                           resolution 800x480
'
'*******************************************************************************
$regfile = "usb1286.dat"
$crystal = 8000000
$hwstack = 512
$swstack = 512
$framesize = 512

'--------------------------- Pin Configuration ---------------------------------
Config Porta = Output : Data_disp_low Alias Porta           'DB0 - DB7
Config Portc = Output : Data_disp_high Alias Portc          'DB8 - DB15
Rs_disp Alias Portf.4 : Config Rs_disp = Output             'Command/Data pin
Wr_disp Alias Portf.5 : Config Wr_disp = Output             'Write pin
Res_disp Alias Portf.6 : Config Res_disp = Output           'Reset pin
Res_disp = 1

Cs_disp Alias Portf.7 : Config Cs_disp = Output             'Chip Select
Cs_disp = 0

'-------------------------------- Library --------------------------------------
Const Portrait = 0                                          '1=Portrait, 0=Landscape
Const Rotate_180 = 0                                        '1=Rotated,  0=Not Rotated

Config Submode = New : $include "SSD1963 16bit library.inc" 'Include library

'---------------------------- Fonts and Pictures -------------------------------
' You need to include Fonts and Pictures below the "End"
'-------------------------------------------------------------------------------
'
' For load Pictures from SPI-ROM you must configure SPI:

Config Spi = Hard , Interrupt = Off , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
Spsr.0 = 1 : Spcr.0 = 0 : Spcr.1 = 0                        'F_spi = F_osc / 2
Ss_spi_rom Alias Portb.6 : Config Ss_spi_rom = Output : Ss_spi_rom = 1       'Chip Select pin
Spiinit




'================================ Test Program =================================

Dim Count As Word , Text As String * 16 , N As Word , M As Word , B As Word , I As Byte

Display_init                                                ' Initialize Display

Do
'(
   Lcd_clear White
   Restore Font12x16
   Lcd_text "TFT LCD Display with Controller SSD1963" , 160 , 35 , Darkred , White       '****** Text
   Restore Font25x32
   Lcd_text "Resolution 800x480 pixels" , 90 , 90 , Darkgreen , White
   Restore Font36x56 : Digit_font = 1
   For Count = 1200 To 1208
      Text = Str(count)
      Lcd_text Text , 310 , 190 , Blue , White
      Waitms 500
   Next Count
   Digit_font = 0

   Restore Font25x32
   Lcd_text "Negative  " , 290 , 380 , Black , White        '****** Negative
   Lcd_negative 1
   Restore Font36x56 : Digit_font = 1
   For Count = 1209 To 1217
      Text = Str(count)
      Lcd_text Text , 310 , 190 , Blue , White
      Waitms 500
   Next Count
   Digit_font = 0

   Restore Font25x32
   Lcd_text " Normal   " , 290 , 380 , Black , White
   Lcd_negative 0
   Restore Font36x56 : Digit_font = 1
   For Count = 1218 To 1224
      Text = Str(count)
      Lcd_text Text , 310 , 190 , Blue , White
      Waitms 500
   Next Count
   Digit_font = 0


   Lcd_clear White
   Restore Color8x8                                         '****** Color Font Text
   Lcd_text_color "Color Font text 'Color8x8'" , 275 , 65 , Black , White
   Restore Color16x16
   Lcd_text_color "Font 'Color16x16' " , 245 , 100 , Darkgreen , White
   Wait 2


   Lcd_clear White
   Restore Font25x32
   Lcd_text "Clear Screen B&W" , 220 , 200 , Black , White  '****** Clear Screen
   Wait 2
   Lcd_clear Black : Waitms 500
   Lcd_clear White : Waitms 500
   Lcd_clear Black : Waitms 500
   Lcd_clear White
   Lcd_text "Clear Screen with color" , 130 , 200 , Blue , White
   Wait 2
   Lcd_clear Red : Waitms 500
   Lcd_clear Green : Waitms 500
   Lcd_clear Blue : Waitms 500



   Lcd_clear Black
   Lcd_text "Pixels" , 310 , 10 , White , Black             '****** Set Pixel
   Waitms 500
   For Count = 10 To 780 Step 64
      For N = 50 To 460 Step 64
         Lcd_set_pixel Count , N , White
      Next N
   Next Count
   Waitms 500
   For Count = 42 To 780 Step 32
      For N = 82 To 460 Step 32
         Lcd_set_pixel Count , N , White
      Next N
   Next Count
   Waitms 500
   For Count = 26 To 780 Step 16
      For N = 66 To 460 Step 16
         Lcd_set_pixel Count , N , White
      Next N
   Next Count
   Waitms 500
   For Count = 18 To 780 Step 8
      For N = 58 To 460 Step 8
         Lcd_set_pixel Count , N , White
      Next N
   Next Count
   Wait 2

')
Restore Font25x32

   Lcd_clear White                                          '****** Line
   Lcd_text "Line" , 340 , 10 , Blue , White
   Lcd_fill_box 40 , 50 , 42 , 440 , Black
   Lcd_fill_box 40 , 440 , 760 , 442 , Black
   Lcd_line 30 , 70 , 40 , 50 , Black
   Lcd_line 50 , 70 , 40 , 50 , Black
   Lcd_line 31 , 70 , 41 , 50 , Black
   Lcd_line 51 , 70 , 41 , 50 , Black
   Lcd_line 740 , 430 , 760 , 440 , Black
   Lcd_line 740 , 431 , 760 , 441 , Black
   Lcd_line 740 , 450 , 760 , 440 , Black
   Lcd_line 740 , 451 , 760 , 441 , Black
   For Count = 390 To 52 Step - 50
      Lcd_fill_box 40 , Count , 740 , Count , Green
   Next
   For Count = 90 To 740 Step 50
      Lcd_fill_box Count , 50 , Count , 439 , Green
   Next
   Lcd_text "0" , 10 , 442 , Black , White
   Lcd_text "Y" , 10 , 30 , Black , White
   Lcd_text "X" , 762 , 442 , Black , White
   M = 220
   For Count = 60 To 740 Step 10
      B = Count + 10
      N = Rnd(300) + 100
      Lcd_line Count , M , B , N , Red
      M = N
   Next Count
   Wait 2


'(
   Lcd_clear White
   Lcd_text "Circle" , 300 , 10 , Black , White             '******* Circle
   Lcd_circle 280 , 200 , 80 , Blue
   Lcd_circle 280 , 200 , 79 , Blue
   Lcd_circle 400 , 200 , 80 , Black
   Lcd_circle 400 , 200 , 79 , Black
   Lcd_circle 520 , 200 , 80 , Red
   Lcd_circle 520 , 200 , 79 , Red
   Lcd_circle 340 , 320 , 80 , Brown
   Lcd_circle 340 , 320 , 79 , Brown
   Lcd_circle 460 , 320 , 80 , Green1
   Lcd_circle 460 , 320 , 79 , Green1
   Wait 2


   Lcd_clear Cyan
   Lcd_text "Fill Circle" , 260 , 10 , Brown , Cyan         '******* Fill Circle
   Lcd_fill_circle 340 , 160 , 40 , Blue
   Lcd_fill_circle 460 , 160 , 40 , Red
   Lcd_fill_circle 400 , 220 , 40 , Darkgreen
   Wait 2


   Lcd_clear Blue
   Lcd_text "Filled Box" , 280 , 220 , Yellow , Blue        '****** Filled Box
   Lcd_fill_box 50 , 50 , 130 , 130 , White
   Lcd_fill_box 670 , 50 , 750 , 130 , Red
   Lcd_fill_box 50 , 350 , 130 , 430 , Yellow
   Lcd_fill_box 670 , 350 , 750 , 430 , Cyan
   Wait 2



   Lcd_clear Gold
   Lcd_text "Box" , 360 , 10 , Darkblue , Gold              '****** Box
   Lcd_box 50 , 50 , 750 , 430 , Darkblue
   Lcd_box 120 , 100 , 680 , 380 , Black
   Lcd_box 190 , 150 , 610 , 330 , Darkmagenta
   Lcd_box 260 , 200 , 560 , 280 , Brown
   Lcd_box 330 , 250 , 490 , 230 , Red
   Wait 2



   Lcd_clear White
   Lcd_text "256 colors Picture" , 190 , 20 , Darkblue , White       '****** BGC Picture
   Restore Elefant : Lcd_pic_bgc 80 , 160
   Restore Elefant : Lcd_pic_bgc 240 , 160
   Restore Cat : Lcd_pic_bgc 400 , 170
   Restore Cat : Lcd_pic_bgc 560 , 170
   Wait 2



   Lcd_clear White
   Restore Font25x32
   Lcd_text "65536 colors Picture" , 140 , 20 , Darkblue , White       '****** 16-bit Picture
   Restore Coffee : Lcd_pic_sram 80 , 120 , 160 , 120
   Restore Coffee : Lcd_pic_sram 240 , 120 , 160 , 120
   Restore Coffee : Lcd_pic_sram 400 , 120 , 160 , 120
   Restore Coffee : Lcd_pic_sram 560 , 120 , 160 , 120
   Wait 1


   Lcd_clear White
   Restore Font25x32
   Lcd_text "65536 colors Picture" , 140 , 120 , Darkblue , White       '****** 16-bit Picture from SPI
   Lcd_text "from external SPI-ROM" , 128 , 180 , Darkblue , White
   Wait 1
   Lcd_pic_spi 0 , 0 , 800 , 480 , 0


   For I = 0 To 255 Step 4                                  '****** Brightness 0...255
     Lcd_brightness I
     Temp_string_ssd1963 = "Brightness=" + Str(i) + "     "
     Lcd_text Temp_string_ssd1963 , 0 , 0 , White , Brown
   Next I
   Lcd_brightness 127

   For I = 0 To 127 Step 2                                  '****** Contrast 0...127
     Lcd_contrast I
     Temp_string_ssd1963 = "Contrast=" + Str(i) + "       "
     Lcd_text Temp_string_ssd1963 , 0 , 0 , White , Brown
   Next I
   Lcd_contrast 64

   For I = 0 To 127 Step 2                                  '****** Saturation 0...127
     Lcd_saturation I
     Temp_string_ssd1963 = "Saturation=" + Str(i) + "     "
     Lcd_text Temp_string_ssd1963 , 0 , 0 , White , Brown
   Next I
   Lcd_saturation 64
   Lcd_text "Saturation=64      " , 0 , 0 , White , Brown
   Wait 2

')
Loop

End                                                         'end program
'-------------------------------------------------------------------------------
$include "color8x8.font"
$include "color16x16.font"
$include "Font12x16.font"
$include "Font25x32.font"
$include "Font36x56.font"
$inc Coffee , Nosize , "Coffee.bin"
Cat:
$bgf "Cat.bgc"
Elefant:
$bgf "Elefant.bgc"